10 if devtype(#1)<0:open#1,con             : rem open channel if not open
20 print#1,"starting pass 1..."                   : rem say hello
30 DIM names$(300,20)                      : rem array to hold subnames
40 arrcounter%=1
50 output$='dev1_prowess_bas_output'
60 outchan%=fop_over(output$)              : rem open "output" file
70 rem valchan%=fop_over('dev1_prowess_old_tagvalue_asm')    : rem old file for tagvalues
80 rem strchan%=fop_over('dev1_prowess_old_tagstrings_asm')  : rem old file for strings
90 arrchan%=fop_over('dev1_prowess_asm_tagstrings_asm')
100 valuechan%=fop_over('dev1_prowess_asm_tagvalue_asm')  : rem file for tagvalues
110 inclchan%=fop_over('dev1_prowess_asm_tagincludes_asm'): rem file for assembler includes
120 rem now the first phase: make the "output" file and the old files
130 rem and also make the array
140 restore 140
150 header                        : rem make headers in the output files
160 rep lp%
170   if eof():exit lp%
180   read file$
190   print file$&' ....'
200   print#outchan%,"   REM  .... "&file$
210   inchan%=fop_in("dev1_prowess_c68_include_"&file$)
220   get_defines inchan%,outchan%
230   close#inchan%
240 end rep lp%
250 asort names$,0
260 print_array         : rem print the aray in _asm file format
270 footer
280 print "pass 1 finished ok"
290 print "starting pass 2..."
300 close#outchan%
310 rem close#valchan%
320 rem close#strchan%
330 close#arrchan%
340 rem now the second pass: make the tokens & values and
350 rem print them into an assmbler file
360 make_asm
370 print#valuechan%;"   end"
380 close#valuechan%
390 print#inclchan%;"   list"
400 close#inclchan%
410 print "-finished-"
420 :
430 rem data "PWTypeDef_h"
440 rem data "PWSystem_h"
450 data "PWStdTags_h"
460 rem data "PWObject_h"
470 rem data "PWJob_h"
480 rem data "PWHandler_h"
490 rem data "PWEvent_h"
500 rem data "PWConfig_h"
510 data "ProWesS_h"
520 :
530 :
540 def fn do_tabs$(a$)
550   local b$,c$,tab%,lp%,t%
560   b$="":c$=""
570   rep lp%
580     tab%=chr$(9) instr a$
590     if not tab%:exit lp%
600     if tab%=1:a$='        '&a$(2 to):next lp%
610     t%=tab% mod 8
620     a$=a$(1 to tab%-1)&fill$(' ',8-t%)&a$(tab%+1 to)
630   end rep lp%
640   return a$
650 end def do_tabs$
660 :
670 def proc get_defines(inchan%,outchan%)
680 rem parses a files, looks for "#define", makes it into a basic line and
690 rem printis it out to outchan%
700 local lp%,a$,b$,loop%,length%,c$
710   rep lp%
720     if eof(#inchan%):exit lp%           : rem do until no more
730     input#inchan%;a$                    : rem get a line
740     length%= len(a$)
750     if length%<7:next lp%               : rem minimum size
760     if a$(1 to 7)=="#define"
770       a$=do_tabs$(a$)                   : rem replace all tabs with spaces
780       c$="":b$=""
790       a$=a$(9 to)                       : rem strip off "#define "
800       b$=strip_space$                   : rem b$=name, a$=rest, c$=comment
810       if b$="" or b$(1 to 3)<>"PW_":print b$:next lp%                 : rem oops
820       IF a$="" or ">>" instr a$ or "<<" instr a$:next lp%
830       if 'error' instr a$ or '\' instr a$ or b$(1)='_':next lp%
840       add_to_array b$                   : rem add all unknown subwords
850       length%=len(b$)
860       print#outchan%,"  ";b$;
870       if length%<26
880         print#outchan%,fill$(' ',26-length%);
890       endif
900       print#outchan%;"= ";
910       length%='0x' instr a$
920       select on length%
930         =0                    : rem do nothing
940         =1:a$="$"&a$(3 to)
950         = remainder
960            a$=a$(1 to length%-1)&"$"&a$(length%+2 to)
970       end select
980       print#outchan%,a$;
990       if c$<>""
1000         print#outchan%,c$
1010       else
1020         print#outchan%
1030       endif
1040 rem      if parse_for_asm_ok%(a$)
1050 rem        print#strchan%,chr$(9);'DC.W';chr$(9);len(b$)-3;",'";b$(4 to);"'"
1060 rem      endif
1070     endif
1080   end rep lp%
1090 end def get_defines
1100 :
1110 def fn strip_space$
1120 rem after this, a$ will be the "value" of the parameter
1130 rem b$ will be the name of the parameter, c$ will be a possible comment
1140 rem a$,b$,c$ are from get_defines
1150 local lp%,s$
1160   lp%= " " instr a$           : rem is there a space?
1170   if not lp%:return ""
1180   b$=a$(1 to lp%-1)           : rem b$=name of the defined variable
1190   a$=a$(lp%+1 to)             : rem a$= rest
1200   for lp%=1 to len (a$)
1210     if a$(1)<>" ":exit lp%
1220     a$=a$(2 to)
1230   end for lp%                 : rem strip off spaces at beginning
1240   lp%='/*' instr a$           : rem is there a comment in the line?
1250   if lp%
1260     c$=': rem' &a$(lp%+2 to)
1270     a$=a$(1 to lp%-1)
1280   endif
1290   return b$
1300 end def strip_space$
1310 :
1320 def fn parse_for_asm_ok% (a$)
1330 rem this decomposes a$ into the fields: value (long) function (word) add (word)
1340 local tagmulti$,tagmask$,a%,value$,function$,add$
1350   tagmulti$="PW_TAGMASK_MULTIPLE"
1360   tagmask$="PW_TAGMASK_STANDARD"
1370   taglist$="PW_TAGMASK_TAGLIST"
1380   a%='+' instr a$
1390   function$="$0":add$="$0"
1400   value$=a$:if '"' instr value$:return 0
1410   if a%
1420     value$=a$(1 to a%-1)
1430     a$=a$(a%+1 to)
1440   endif
1450   if value$(1)='(':value$=value$(2 to)
1460   a%=tagmulti$ instr a$
1470   if a%: a%=a$(a%+20)+1
1480   if a%:function$="$"&a% : rem one more than necessary, to distinguish between
1490                          rem those with index 0, and those not using this function!
1500   a%=tagmask$ instr a$
1510   if a%
1520     add$="1000"
1530   else
1540     add$="0000"
1550   endif
1560   a%=taglist$ instr a$
1570   if a%:add$="4000"&add$
1580   add$="$"&add$
1590   if 'PW' instr value$
1600     value$=o_val$
1610     function$=o_f$
1620     add$=o_a$
1630   endif
1640   print#valchan%,chr$(9);"DC.L";chr$(9);value$;chr$(9);chr$(9);';';b$
1650   print#valchan%,chr$(9);"DC.W";chr$(9);function$
1660   print#valchan%,chr$(9);"DC.L";chr$(9);add$
1670   print#valchan%
1680   o_val$=value$:o_f$=function$:o_a$=add$
1690   return 1
1700 end def old_parse_for_asm_ok%
1710 :
1720 def proc header
1730 :
1740   print#arrchan%;"; strings for types"
1750   print#arrchan%;";  W. Lenerz 1996"
1760   print#arrchan%
1770   print#arrchan%
1780   print#arrchan%;chr$(9);"Section strings"
1790   print#arrchan%;chr$(9);'xdef  strings'
1800   print#arrchan%;"strings";
1810 :
1820   print#valuechan%;"; values for strings for types"
1830   print#valuechan%;";  W. Lenerz 1996"
1840   print#valuechan%
1850   print#valuechan%
1860   print#valuechan%;chr$(9);"Section vals"
1870   print#valuechan%;chr$(9);'xdef  values'
1880   print#valuechan%;"values";
1890 :
1900   print#inclchan%;"; includes for tags"
1910   print#inclchan%;";  W. Lenerz 1996"
1920   print#inclchan%
1930   print#inclchan%;"  nolist";
1940   print#inclchan%
1950 :
1960 end def header
1970 :
1980 def proc footer
1990 :
2000 rem  print#strchan%,chr$(9);'dc.w      -1'
2010 rem  print#valchan%,"   end"
2020 :
2030 rem  print#strchan%,"   end"
2040 :
2050   print#arrchan%,"   end"
2060 end def footer
2070 :
2080 def proc not_used_any_more
2090   print#strchan%;"; strings for types"
2100   print#strchan%;";  W. Lenerz 1996"
2110   print#strchan%
2120   print#strchan%
2130   print#strchan%;chr$(9);"Section strings"
2140   print#strchan%;chr$(9);'xdef  strings'
2150   print#strchan%;"strings";
2160 :
2170   print#valchan%;"; values for strings for types"
2180   print#valchan%;";  W. Lenerz 1996"
2190   print#valchan%
2200   print#valchan%
2210   print#valchan%;chr$(9);"Section vals"
2220   print#valchan%;chr$(9);'xdef  values'
2230   print#valchan%;"values";
2240 end def
2250 :
2260 def proc make_asm
2270 local inchan%,lp%,a$,a%,b$,c$
2280   inchan%=fop_in(output$)
2290   if inchan%<0:return         : rem oops
2300   rep lp%
2310     if eof(#inchan%):exit lp%
2320     input#inchan%,a$
2330     a%="=" instr a$
2340     if not a%:next lp%        : rem oops
2350     b$=a$(1 to a%-1)          : rem name
2360     c$=b$
2370     a$=a$(a%+1 to)            : rem value
2380     b$=no_white$(b$(6 to))
2390     b$=make_token$(b$)
2400     a$=hex$(make_value(a$),32)
2410     print#valuechan%,chr$(9);"DC.L";chr$(9);"$";b$
2420     print#valuechan%,chr$(9);"DC.L";chr$(9);"$";a$;
2430     print#valuechan%,chr$(9);"; ";c$;
2440     print#valuechan%
2450     print#inclchan%,c$(3 to),"EQU","$";a$
2460   end rep lp%
2470     print#valuechan%,chr$(9);"DC.L";chr$(9);"0"
2480   close#inchan%
2490 end def make_asm
2500 :
2510 def fn make_value(a$)
2520 rem this decomposes a$ into the fields: value (long) function (word) add (word)
2530 local tagmulti$,tagmask$,a%,value$,fnction,add$,value,add
2540   tagmulti$="PW_TAGMASK_MULTIPLE"
2550   tagmask$="PW_TAGMASK_STANDARD"
2560   taglist$="PW_TAGMASK_TAGLIST"
2570   a%='+' instr a$
2580   fnction=0:add$="0"
2590   value$=a$:if '"' instr value$:return 0
2600   if a%
2610     value$=a$(1 to a%-1)
2620     a$=a$(a%+1 to)
2630   endif
2640   a%=':' INSTR value$
2650   IF a%:value$=value$(1 TO a%-1)
2660   value$=no_white$(value$)
2670   if value$(1)='(':value$=value$(2 to)
2680   kk$=value$
2690   if 'PW' instr value$
2700     value=o_value
2710     return value
2720   endif
2730   if value$(1)='$'
2740     value=hex(value$(2 to))
2750   else
2760     value=value$
2770   endif
2780   a%=tagmulti$ instr a$
2790   if a%: a%=a$(a%+20)+1
2800   if a%:fnction=PW_TAGMASK_MULTIPLE(a%-1) : rem one more than necessary, to distinguish between
2810                          : rem those with index 0, and those not using this function!
2820   a%=tagmask$ instr a$
2830   if a%
2840     add$="1000"
2850   else
2860     add$="0000"
2870   endif
2880   a%=taglist$ instr a$
2890   if a%:add$="4000"&add$
2900   add=hex(add$)
2910   value=value+fnction+add
2920   o_value=value
2930   return value
2940 end def make_value
2950 :
2960 def fn PW_TAGMASK_MULTIPLE(X)
2970 local a$,a
2980   a$="1"&x&"000000"
2990   return hex(a$)
3000 end def PW_TAGMASK_MULTIPLE
3010 :
3020 def fn make_token$(a$)
3030 rem this makes the token for the string a$
3040 rem the token is one long word, returned as a string in HEX!
3050 rem if there is an error ,this returns ''
3060 local lp%,a%,b$,word$,result$,start%
3070   b$=a$                       : rem keep the parameter intact
3080   result$=''
3090   rep lp%
3100     a%= '_' instr b$          : rem find '_'
3110     if not a%:exit lp%        : rem do until no more
3120     word$=b$(1 to a%-1)
3130     b$=b$(a%+1 to)
3140     a%=-1
3150     rep loop%
3160       a%=a%+1
3170       a%=asearch(names$,word$,a%,0)
3180       if a%<0:exit loop%
3190       if names$(a%)==word$:exit loop%
3200     end rep loop%
3210     if a%<0:return ""       : rem oops !
3220     result$=result$&hex$(a%,8): rem one byte
3230   end rep lp%
3240   a%=-1
3250   rep loop%
3260     a%=a%+1
3270     a%=asearch(names$,b$,a%,0)
3280     if a%<0:exit loop%
3290     if names$(a%)==b$:exit loop%
3300   end rep loop%
3310   if not a%:return ""         : rem oops !
3320   result$=result$&hex$(a%,8)  : rem one more byte
3330   a%=len(result$)             : rem this must be a long word
3340   if a%<8
3350     result$=result$&fill$('0',8-a%)
3360   end if
3370   return result$
3380 end def make_token$
3390 :
3400 def proc add_to_array (a$)
3410 rem this checks whether all the subwords in a name are in the array
3420 local b$,c$,lp%
3430   c$=a$                       : rem keep parameter intact
3440   rep lp%
3450     a%='_' instr c$           : rem is there a '_' in the name?
3460     if not a%:exit lp%        : rem no
3470     b$=c$(1 to a%-1)          : rem b$= word until the '_'
3480     c$=c$(a%+1 to)            : rem a$= the rest of the word
3490     a%=srch%(b$)              : rem is this string already in array?
3500     if a%
3510        names$(arrcounter%)=b$    : rem no, so put it into array
3520        arrcounter%=arrcounter%+1
3530     endif
3540   end rep lp%
3550   a%=srch%(c$)   : rem is last word there?
3560   if a%
3570        names$(arrcounter%)=c$  :
3580        arrcounter%=arrcounter%+1
3590   endif
3600 end def add_to_array
3610 :
3620 def proc print_array
3630 local chan%
3640   for lp%=1 to arrcounter%
3650     print#arrchan%,chr$(9);"DC.W";chr$(9);
3660     print#arrchan%,len(names$(lp%));",'";names$(lp%);"'"
3670   end for lp%
3680 end def print_array
3690 :
3700 def fn srch%(a$)
3710 local lp%,f%
3720   f%=1
3730   for lp%=1 to arrcounter%
3740     if names$(lp%)==a$:f%=0:exit lp%
3750   end for lp%
3760   return f%
3770 end def srch%
3780 DEFine FuNction no_white$(x$)
3790 rem this strips of spaces at  both ends of the string.
3800 rem the string must not contain any spaces in itself, only at the ends
3810   LOCal lp%,res$,a%
3820   res$=x$
3830   REPeat lp%
3840     a%=len(res$)
3850     IF a%<1 THEN EXIT lp%
3860     IF res$(1)<>' ' THEN EXIT lp%
3870     IF a%>1 THEN res$=res$(2 TO )
3880   END REPeat lp%
3890   if " " instr res$ and a%=1:return ""
3900   a%=" " instr res$
3910   if a%:res$=res$(1 to a%-1)
3920   RETurn res$
3930 END DEFine no_white$
